﻿-- Author      : grunkalunca
-- Create Date : 2/7/2010 9:21:49 PM

local TradeShareSingle = CreateFrame("Frame","TradeShareSingle")

function Frame_Single_OnLoad()
	TradeShareSingle:RegisterEvent("TRADE_SKILL_SHOW")
	TradeShareSingle:SetScript("OnEvent",TradeShareSingle.OnEvent)
end

function TradeShareSingle:OnEvent(event, ...)
	if event == "TRADE_SKILL_SHOW" then
		self:Initialize()
	end
end

function Frame_Single_EditBox_OnTextChanged()
end

function Frame_Single_Button_OnClick()
	Frame_Single:Hide()
end

function TradeShareSingle:Initialize()
	if self.initialized or not IsAddOnLoaded("Blizzard_TradeSkillUI") then return end 
		
	local parent = TradeSkillFrame
	if SkilletFrame then
		parent = SkilletFrame
		self:UnregisterAllEvents()
	end	

    	TradeShareSingle:CreateButton()
	self.initialized = true
end

function TradeShareSingle:CreateButton()
	TS_Button = CreateFrame("BUTTON","TS_OpenButtonTradeSkill",TradeSkillFrame,"UIPanelButtonTemplate")

	TS_Button:SetFrameStrata('MEDIUM')

	TS_Button:SetPoint("TOPLEFT",TradeSkillFrame,"TOPRIGHT", -280, -1)

	TS_Button:SetHeight(19)
	TS_Button:SetWidth(58)
	TS_Button:SetText('Share')
	TS_Button:Show()
	TS_Button:SetScript("OnClick",function (self) TradeShareSingle:OnClick(); end)
end

function TradeShareSingle:OnClick()
	local isLinked, _ = IsTradeSkillLinked()
	if (isLinked ~= 1) then
		local link = GetTradeSkillListLink()
		local playerName = UnitName("player")
		
		if (link == nil) then
			return;
		end
		
		local linkURI = CreateTradeShareLink(link, playerName, getMyGuild(), GetRealmName(), "http://www.wowtradeshare.com/share?")
		local selectedTrade = GetTradeSkillLine()

		Frame_Multi:Hide()
		Frame_Single:Hide()
		Frame_Single_FontStringTitle:SetText(selectedTrade .. " post for " .. playerName .. " with " .. GetNumTradeSkills() .. " recipes")
		Frame_Single_EditBox:SetText("")
		Frame_Single_EditBox:SetText(linkURI)
		Frame_Single:Show()
		Frame_Single_EditBox:SetFocus()
	end
end

