﻿-- Author      : grunkalunca
-- Create Date : 2/5/2010 10:51:36 PM

function ParseTradeLink(link)
	if link and strlen(link) > 0 then
		local pattern = '|cffffd000|Htrade:%d+:%d+:%d+:(%x+):[A-Za-z0-9+/]+|h%[(.+)%]|h|r'
		local _, _, id, profession = strfind(link, pattern)
		if strlen(id) > 0 and strlen(profession) > 0 then
			return link, id, profession
		end
	end
	return nil, nil, nil
end

function FindTradeLinks(msg)
	local pattern = '|cffffd000|Htrade:%d+:%d+:%d+:%x+:[A-Za-z0-9+/]+|h%[[^]]+%]|h|r'
	local linkTable = {}
	local i = 1

	if msg ~= nil then
		for link in string.gmatch(msg, pattern) do
			linkTable[i] = link
			i = i + 1
		end
	end
	return linkTable
end

function adler32(s)
	local length = string.len(s)

	local A = 1
	local B = 0
	for i=1, length do
		A = (A + string.byte(s, i)) % 65521
		B = (B + A) % 65521
	end

	return B * 65536 + A
end

function getMyGuild()
	local guild, rank, rankId = GetGuildInfo("player")

	if guild ~= nil then
		return guild
	else
		return "None"
	end
end

function CreateTradeShareLink(link, charName, guild, realm, prefix)
	local linkRaw = gsub(link, "\124", "\124\124")
	local enFaction, locFaction = UnitFactionGroup("player")
	local _, build, _, _ = GetBuildInfo()
	local locale = GetCVar("portal")

	local tradeShareString = "c=" .. charName .. 
		"&f=" .. enFaction .. 
		"&r=" .. realm ..
		"&l=" .. locale ..
		"&g=" .. guild .. 
		"&b=" .. build;

	local tradeShareLink = tradeShareString .. "&link=" .. linkRaw
	local tradeShareValidate = tradeShareString .. "&link=" .. link
	local valid = adler32(tradeShareValidate)
               
	return prefix .. tradeShareLink .. "&v=" .. valid
end

function ValidateTradeShareLink(v)
	local seconds = time() - tonumber(v[1])
	if seconds > 72 * 3600 then
		return nil
	end
	
	if not strfind(v[2], '&l=') then
		local link = strfind(v[2], '(.*)&v=%d+')
		if link == nil then
			v = nil
		else
			link = link .. "&l=" .. GetCVar("portal")
			v[2] = link .. "&v=" .. adler32(link)
		end
	end
	
	return v
end

